Value -

# abstract struct Value

- Value
- Object

## Overview

`Value` is the base type of the primitive types (`Nil`, `Bool`, `Char`, `Number`), `Symbol`, `Pointer`, `Tuple`, `StaticArray` and all structs.

A `Value` is passed by value: when you pass it to methods, return it from methods or assign it to variables, a copy of the value is actually passed. This is not important for nil, bools, integers, floats, symbols, pointers and tuples, because they are immutable, but with a mutable `Struct` or with a `StaticArray` you have to be careful. Read their documentation to learn more about this.

## Direct Known Subclasses

- Bool
- Char
- Class
- Enum
- NamedTuple(**T)
- Nil
- Number
- Pointer(T)
- Proc(*T, R)
- StaticArray(T, N)
- Struct
- Symbol
- Tuple(*T)
- Union(*T)

## Defined in:

## Instance Method Summary

- #==(other : JSON::Any)
- #==(other : YAML::Any)
- #==(other)

  Returns `false`.

- #dup

  Returns a shallow copy of this object.

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash(hasher)
hash hash, inspect(io : IO) : Nil
inspect : String inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try, unsafe_as(type : T.class) forall T unsafe_as

### Constructor methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io : String | IO) : self from_yaml

## Instance Method Detail

def ==(other : JSON::Any) #
def ==(other : YAML::Any) #
def ==(other) #

Returns `false`.

def dup #

Returns a shallow copy of this object.

Because `Value` is a value type, this method returns `self`, which already involves a shallow copy of this object because value types are passed by value.